%define version fon_q_1.6.0.28_r94
%define trans_mark transcoding_mark
%define trans_ver fon_q_1.6.0.r89

Summary: PBXtra Core
Name: pbxtra-core
Distribution: RedHat
License: GPL
Version: %{version}
Release:	10
Group: Utilities/System
Vendor: Fonality
Packager: Samy Kamkar <samy@fonality.com>
BuildRoot: /tmp/asterisk
Source: %{name}-%{version}.tar.gz

# Turn off automatic dependency generation 
Autoreq: 0 

Requires:	libpri
Requires:	dahdi-linux
#Requires:	dahdi-tools
#Requires:	dahdi-tools-devel
Requires:	libidn
Requires:	libidn-devel
Requires:	coredumper
Requires:	coredumper-devel
Obsoletes:	pbxtra-core = 1.2.17_fon_o_beta2
Obsoletes:	pbxtra-core = 1.2.17_fon_p
Obsoletes:	pbxtra-core = 1.2.17_fon_p_alpha1
Obsoletes:	pbxtra-core = fon_p_1.2.17_alpha1
Obsoletes:	pbxtra-core = fon_p_1.2.17_alpha2
Obsoletes:	pbxtra-core = fon_p_1.2.17_alpha3

%description
IP PBX by Fonality


%pre
if [ -e /etc/init.d/asterisk ]; then
	/etc/init.d/asterisk stop
	mv /etc/init.d/asterisk /etc/init.d/asterisk.bak
fi

if [ -e /usr/sbin/safe_asterisk ]; then
	mv /usr/sbin/safe_asterisk /usr/sbin/safe_asterisk.bak
fi

if [ -e /usr/lib/asterisk/modules/codec_g729-ast16-gcc4-glibc-pentium4.so ]; then
	mkdir -p /tmp/g729
	cp /usr/lib/asterisk/modules/codec_g729-ast16-gcc4-glibc-pentium4.so /tmp/g729/.
	cp /var/lib/asterisk/licenses/G729-*.lic /tmp/g729/.
fi

if [ -e /usr/lib/asterisk/modules/chan_woomera.so ]; then
	mkdir -p /tmp/woomera
	cp --reply=yes /usr/lib/asterisk/modules/chan_woomera.so /tmp/woomera/.
fi

if [ -d /usr/lib/asterisk/modules ]; then
	pushd /usr/lib/asterisk
	tar cvf modules.tar ./modules
	rm -rf modules
	popd
fi

if [ -d /etc/asterisk ]; then
	cp --reply=yes -r /etc/asterisk /etc/asterisk.pre16.`date +%s`
fi

# versions between 65~77 don't have transcoding mark, make one for them

pre_ast_ver=`/usr/sbin/asterisk -V 2>&1 | grep -E "Asterisk.+-samy-r[0-9]+" | sed 's/^Asterisk.*-samy-r//'`

echo "Previous Asterisk version is $pre_ast_ver"

if [ $pre_ast_ver ]; then
	if [ $pre_ast_ver -gt 64 -a $pre_ast_ver -lt 78 ]; then
		touch /var/lib/asterisk/sounds/%{trans_mark}-fon_q_1.6.0.r65
	fi
fi

if [ ! -e /var/lib/asterisk/sounds/%{trans_mark}-%{trans_ver} ]; then
	if [ -d /var/lib/asterisk/sounds ]; then
		cp --reply=yes -r /var/lib/asterisk/sounds /var/lib/asterisk/sounds.pre16.`date +%s`
	fi
fi

%prep
%setup -n trunk


%build
./configure
make


%install
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d/
make DESTDIR=$RPM_BUILD_ROOT install
cp $RPM_BUILD_DIR/trunk/contrib/init.d/rc.redhat.asterisk $RPM_BUILD_ROOT/etc/rc.d/init.d/asterisk
mkdir -p $RPM_BUILD_ROOT/var/run/asterisk

# Have to delete these 2 hidden files, otherwise rpmbuild will complain
rm -f $RPM_BUILD_ROOT/var/lib/asterisk/sounds/.asterisk-core-sounds-en*


%post
if [ -e /etc/asterisk/parking.conf ]; then
	ln -sf /etc/asterisk/parking.conf /etc/asterisk/features.conf
fi

ln -sf /var/spool/asterisk/voicemail/default /var/spool/asterisk/vm
ln -sf /var/spool/asterisk/vm /var/lib/asterisk/sounds/vm

if [ -d /tmp/g729 ]; then
	cp /tmp/g729/codec_g729-ast16-gcc4-glibc-pentium4.so /usr/lib/asterisk/modules/
	cp /tmp/g729/G729-*.lic /var/lib/asterisk/licenses/.
	chown nobody /var/lib/asterisk/licenses/G729-*.lic
	rm -rf /tmp/g729
fi

if [ -d /tmp/woomera ]; then
	cp /tmp/woomera/chan_woomera.so /usr/lib/asterisk/modules/.
	rm -rf /tmp/woomera
fi

if [ -e /etc/asterisk/modules.conf ]; then
	/usr/bin/perl -pi -e 's/^load => chan_modem.so/noload => chan_modem.so/' /etc/asterisk/modules.conf
fi

if [ -e /etc/init.d/asterisk ]; then
	/etc/init.d/asterisk start
fi

if [ ! -e /etc/init.d/asterisk ]; then
	if [ -e /etc/init.d/asterisk.bak ]; then
		cp /etc/init.d/asterisk.bak /etc/init.d/asterisk
		/etc/init.d/asterisk start
	fi
fi

if [ -e /etc/asterisk/FONmon.conf ]; then
	perl -pi -e 's/^(checkhashlocks) = 1/$1 = 0/g;' \
	-e 's/^(fix_hash_contention) = 0/$1 = 1/g;' \
	-e 's/^(checkcontention) = 0/$1 = 1/g;' \
	-e 's/^(fix_channel_contention) = 0/$1 = 1/g;' \
	-e 's/^(astlog_interval) = \d+/$1 = 300/g' /etc/asterisk/FONmon.conf
fi

if [ ! -e /var/lib/asterisk/sounds/%{trans_mark}-%{trans_ver} ]; then
	if [ -e /var/adm/bin/transcode.pl ]; then
		perl /var/adm/bin/transcode.pl `find /var/lib/asterisk/sounds | egrep 'wav$|gsm$'` `find /var/lib/asterisk/mohmp3/ | grep 'mp3$'`
		chown -R nobody:nobody /var/lib/asterisk/sounds
		chown -R nobody:nobody /var/lib/asterisk/mohmp3
		rm -f /var/lib/asterisk/sounds/%{trans_mark}-*
		touch /var/lib/asterisk/sounds/%{trans_mark}-%{trans_ver}
	else
		echo "Error: /var/adm/bin/transcode.pl not found, installation incomplete!"
	fi
fi


%preun
# only stop asterisk if it's uninstall instead of upgrading
if [ "$1" -eq "0" ]; then
        if [ -e /etc/init.d/asterisk ]; then
                /etc/init.d/asterisk stop
        fi
fi


%postun
# only remove transcoding mark when it's uninstall instead of upgrading
if [ "$1" -eq "0" ]; then
	rm -f /var/lib/asterisk/sounds/%{trans_mark}-*
fi

%files
#
# Configuration files
#
%attr(0755,nobody,nobody) %dir    /etc/asterisk
# Skip samples
#%config(noreplace) %attr(0640,nobody,nobody) /etc/asterisk/*.conf
#%config(noreplace) %attr(0640,nobody,nobody) /etc/asterisk/*.adsi
#%config(noreplace) %attr(0640,nobody,nobody) /etc/asterisk/extensions.ael

#
# RedHat specific init script file
#
%attr(0755,root,root)       /etc/rc.d/init.d/asterisk

#
# Modules
#
%attr(0755,root,root) %dir /usr/lib/asterisk
%attr(0755,root,root) %dir /usr/lib/asterisk/modules
%attr(0755,root,root)      /usr/lib/asterisk/modules/*

#
# Asterisk
#
%attr(0755,root,root)      /usr/sbin/*

#
# CDR Locations
#
%attr(0755,nobody,root) %dir /var/log/asterisk
%attr(0755,nobody,root) %dir /var/log/asterisk/cdr-csv

#
# Running directories
#
%attr(0755,nobody,nobody) %dir /var/run/asterisk

#
# Sound files
#
%attr(0755,nobody,root) %dir /var/lib/asterisk
%attr(0755,nobody,root) %dir /var/lib/asterisk/sounds
# all the files and subdirectories wil be included
%attr(0755,nobody,root)      /var/lib/asterisk/sounds/*


# Skip samples
#%attr(0755,nobody,root) %dir /var/lib/asterisk/mohmp3
#%attr(0644,nobody,root)      /var/lib/asterisk/mohmp3/*

%attr(0755,nobody,root) %dir /var/lib/asterisk/images
%attr(0644,nobody,root)      /var/lib/asterisk/images/*
%attr(0755,nobody,root) %dir /var/lib/asterisk/keys
%attr(0644,nobody,root)      /var/lib/asterisk/keys/*
%attr(0755,nobody,root) %dir /var/lib/asterisk/agi-bin
%attr(0755,nobody,root)      /var/lib/asterisk/agi-bin/*

#
# Man page
#
%attr(0644,root,root)	   /usr/share/man/man8/*

#
# Firmware
#
%attr(0755,nobody,root) %dir /var/lib/asterisk/firmware
%attr(0755,nobody,root) %dir /var/lib/asterisk/firmware/iax
%attr(0755,nobody,root)      /var/lib/asterisk/firmware/iax/*

#
# Example voicemail files
#
# Skip samples
%attr(0755,nobody,root) %dir /var/spool/asterisk
%attr(0755,nobody,root) %dir /var/spool/asterisk/voicemail
%attr(0755,nobody,root) %dir /var/spool/asterisk/voicemail/default

#
# Misc other spool
#
%attr(0755,nobody,root) %dir /var/spool/asterisk/system
%attr(0755,nobody,root) %dir /var/spool/asterisk/tmp

#
# Include files
#
%attr(0644,root,root)      %{_includedir}/*
